# Class __CartesianExporter

java.lang.Object
org.jmol.export.___Exporter
org.jmol.export.__CartesianExporter

Direct Known Subclasses:
  `_IdtfExporter, _MayaExporter, _ObjExporter, _VrmlExporter, JSExporter`

public abstract class __CartesianExporter extends ___Exporter

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`canCapCylinders`
`protected boolean`
`noColor`
`protected M4`
`sphereMatrix`
`protected A4`
`viewpoint`

### Fields inherited from class ___Exporter

`apertureAngle, backgroundColix, cameraDistance, cameraPosition, center, commandLineOptions, commentChar, degreesPerRadian, depthZ, export3D, exportScale, fileName, fixedRotationCenter, gdata, lightSource, lineWidthMad, out, privateKey, referenceCenter, scalePixelsPerAngstrom, screenHeight, screenWidth, slabZ, solidOnly, tempP1, tempP2, tempP3, tempV1, tempV2, tm, vwr`

## Constructor Summary

Constructors
Constructor
Description
`__CartesianExporter()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`fillTriangle(short colix, T3 ptA, T3 ptB, T3 ptC, boolean twoSided)`
`protected P3`
`getCameraPosition()`
`protected int`
`getCoordinateMap(T3[] vertices, int[] coordMap, BS bsValid)`
`protected P3`
`getModelCenter()`
`protected int[]`
`getNormalMap(T3[] normals, int nNormals, BS bsValid, Lst<String> vNormals)`
`protected abstract void`
`outputCircle(P3 pt1, P3 pt2, float radius, short colix, boolean doFill)`
`protected abstract void`
`outputCone(P3 ptBase, P3 ptTip, float radius, short colix)`
`protected abstract boolean`
`outputCylinder(P3 ptCenter, P3 pt1, P3 pt2, short colix1, byte endcaps, float radius, P3 ptX, P3 ptY, boolean checkRadius)`
`protected abstract void`
`outputEllipsoid(P3 center, P3[] points, short colix)`
`protected abstract void`
`outputFace(int[] is, int[] coordMap, int faceVertexMax)`
`protected void`
`outputIndices(int[][] indices, int[] map, int nPolygons, BS bsPolygons, int faceVertexMax)`
`protected void`
`outputSolidPlate(P3 tempP1, P3 tempP2, P3 tempP3, short colix)`
`protected abstract void`
`outputSphere(P3 ptCenter, float f, short colix, boolean checkRadius)`
`protected abstract void`
`outputTextPixel(P3 pt, int argb)`
`protected abstract void`
`outputTriangle(T3 pt1, T3 pt2, T3 pt3, short colix)`
`protected void`
`setSphereMatrix(T3 center, float rx, float ry, float rz, A4 a, M4 sphereMatrix)`

### Methods inherited from class ___Exporter

`finalizeOutput, finalizeOutput2, fixScreenZ, getByteCount, getColorList, getConeMesh, getExportDate, getJmolPerspective, getRotationMatrix, getRotationMatrix, getTriad, getTriadC, initOutput, opacityFractionalFromArgb, opacityFractionalFromColix, output, output, outputComment, outputFooter, outputHeader, outputJmolPerspective, outputSurface, outputVertex, outputVertices, rgbFractionalFromArgb, rgbFractionalFromColix, round, round, setTempVertex, translucencyFractionalFromColix`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### viewpoint

protected A4 viewpoint

### canCapCylinders

protected boolean canCapCylinders

### noColor

protected boolean noColor

### sphereMatrix

protected M4 sphereMatrix

## Constructor Details

### __CartesianExporter

public __CartesianExporter()

## Method Details

### getModelCenter

protected P3 getModelCenter()

### getCameraPosition

protected P3 getCameraPosition()

### getCoordinateMap

protected int getCoordinateMap(T3[] vertices, int[] coordMap, BS bsValid)

### getNormalMap

protected int[] getNormalMap(T3[] normals, int nNormals, BS bsValid, Lst<String> vNormals)

### outputIndices

protected void outputIndices(int[][] indices, int[] map, int nPolygons, BS bsPolygons, int faceVertexMax)

### outputFace

protected abstract void outputFace(int[] is, int[] coordMap, int faceVertexMax)

### outputCircle

protected abstract void outputCircle(P3 pt1, P3 pt2, float radius, short colix, boolean doFill)

### outputCone

protected abstract void outputCone(P3 ptBase, P3 ptTip, float radius, short colix)

### outputCylinder

protected abstract boolean outputCylinder(P3 ptCenter, P3 pt1, P3 pt2, short colix1, byte endcaps, float radius, P3 ptX, P3 ptY, boolean checkRadius)

### outputEllipsoid

protected abstract void outputEllipsoid(P3 center, P3[] points, short colix)

### outputSphere

protected abstract void outputSphere(P3 ptCenter, float f, short colix, boolean checkRadius)

### outputTextPixel

protected abstract void outputTextPixel(P3 pt, int argb)

### outputTriangle

protected abstract void outputTriangle(T3 pt1, T3 pt2, T3 pt3, short colix)

### fillTriangle

protected void fillTriangle(short colix, T3 ptA, T3 ptB, T3 ptC, boolean twoSided)

Specified by:
  `fillTriangle` in class `___Exporter`

### outputSolidPlate

protected void outputSolidPlate(P3 tempP1, P3 tempP2, P3 tempP3, short colix)

Parameters:
  `tempP1` -
  `tempP2` -
  `tempP3` -
  `colix` -

### setSphereMatrix

protected void setSphereMatrix(T3 center, float rx, float ry, float rz, A4 a, M4 sphereMatrix)